#pragma semicolon 1

#include <sourcemod>
#include <sdktools_entinput>
#include <vip>

public Plugin:myinfo = 
{
	name	= "VIP [Water Attack]",
	author	= "wS",
	version = "1.2.4"
};

#define ITEM_NAME "water_attack"

new bool:g_bAccess[MAXPLAYERS + 1];
new Float:g_fLastDmgTime[MAXPLAYERS + 1];

public OnPluginStart()
{
	if (!VIP_RegisterItem(ITEM_NAME, VIP_ITEM_TOGGLE)) SetFailState("VIP_RegisterItem error (%s)", ITEM_NAME);
	HookEvent("player_hurt", player_hurt, EventHookMode_Post);
}

///////////////////////////////////////////////////////////////////////////////////

public bool:VIP_CurrentItemValue(client, ItemID, String:ItemValue[], ItemValueSize)
{
	if (g_bAccess[client])
	{
		IntToString(1, ItemValue, ItemValueSize);
		return true;
	}
	ItemValue[0] = 0;
	return false;
}

public VipGiveAction:VIP_GiveAccess(client, ItemID, String:ItemValue[ITEM_INFO_LENGTH], bool:bCallAfterAdminAction, CURRENT_ACCESS, Handle:kv)
{
	if (g_bAccess[client]) return VGA_AlreadyEnabled;
	SetStatus(client, true);
	return VGA_Continue;
}

public VIP_TakeAccess(client, ItemID, bool:bToggledByClient)
{
	SetStatus(client, false);
}

stock SetStatus(client, bool:enabled)
{
	g_bAccess[client] = enabled;
	VIP_NotifyItemStatusChanged(client, ITEM_NAME, enabled);
}

///////////////////////////////////////////////////////////////////////////////////

public player_hurt(Handle:event, const String:name[], bool:silent)
{
	if (g_bAccess[GetClientOfUserId(GetEventInt(event, "attacker"))])
	{
		decl Float:fTime, v;
		if (((fTime = GetGameTime()) - g_fLastDmgTime[(v = GetClientOfUserId(GetEventInt(event, "userid")))]) > 0.02)
		{
			g_fLastDmgTime[v] = fTime;
			SetVariantString("WaterSurfaceExplosion");
			AcceptEntityInput(v, "DispatchEffect");
		}
	}
}

public OnClientDisconnect_Post(client)
{
	g_bAccess[client] = false;
	g_fLastDmgTime[client] = 0.0;
}